  DEFINT A-Z
  CONST Num$ = "0123456789"
  VIEW PRINT
  COLOR 14, 0
  CLS
  LOCATE 1, 23
  COLOR 9
  PRINT "BASE10 FILE TO FILEBYTE CONVERTER"
  LOCATE 3, 1, 1
  COLOR 15
  PRINT "Base10 FileName: ";
  COLOR 14
  LINE INPUT ; InFile$
  InFile$ = UCASE$(LTRIM$(RTRIM$(InFile$)))
  IF InFile$ = "" THEN
    VIEW PRINT
    COLOR 7, 0
    CLS
    SYSTEM
  END IF
  IF LEN(DIR$(InFile$)) = 0 THEN
    RUN
  END IF
  InFile = FREEFILE
  OPEN InFile$ FOR BINARY AS InFile LEN = 1
  COLOR 15
  PRINT TAB(50); " FileLength:";
  COLOR 14
  PRINT LOF(InFile); "Bytes"
Lab1:
  VIEW PRINT 5 TO 24
  IF Flag = 0 THEN
    CLS
  END IF
  LOCATE 5, 1, 0
  IF Flag THEN
    CLOSE
    COLOR 15
    KILL OutFile$
    LOCATE 9, 1
    PRINT "This is NOT a BASE10 converted file!"
    LOCATE 23, 39, 1
    WHILE INKEY$ = ""
    WEND
    RUN
  END IF
  LOCATE 5, 1, 1
  COLOR 15
  FileLength# = 4 * LOF(InFile) / 10
  IF FileLength# <> FIX(FileLength#) THEN
    FileLength# = FIX(FileLength#) + 1
  END IF
  PRINT "OutPut FileName w/Approximate Length"; FileLength#; "Bytes: ";
  COLOR 14
  LINE INPUT ; OutFile$
  OutFile$ = UCASE$(LTRIM$(RTRIM$(OutFile$)))
  IF OutFile$ = "" THEN
    CLOSE
    RUN
  END IF
  IF LEN(DIR$(OutFile$)) THEN
    GOTO Lab1
  END IF
  OutFile = FREEFILE
  OPEN OutFile$ FOR BINARY AS OutFile LEN = 1
  VIEW PRINT 13 TO 24
  CLS
  COLOR 15
  PRINT "Base10 File Byte Number:";
  LOCATE 15, 1
  PRINT "Base256 File Byte Number:";
  COLOR 14
  InBuffer$ = STRING$(1, 32)
  OutBuffer$ = STRING$(1, 32)
  Start& = 1
  Flag& = 0
  Carry = 0
Engine:
  FOR X& = Start& TO LOF(InFile)
    GET InFile, X&, InBuffer$
    IF INSTR(Num$, InBuffer$) = 0 THEN
      Flag = -1
      GOTO Lab1
    END IF
    InBuffer = VAL(InBuffer$) + Carry
    OutBuffer = InBuffer \ 256
    Remainder = InBuffer MOD 256
    Carry = 10 * Remainder
    OutBuffer$ = RIGHT$(STR$(OutBuffer), 1)
    PUT InFile, X&, OutBuffer$
    IF OutBuffer = 0 THEN
      IF X& = Start& OR X& = Flag& THEN
        Flag& = X& + 1
      END IF
    END IF
  NEXT X&
  Carry = 0
  Byte = Remainder
  OutBuffer$ = CHR$(Remainder)
  PUT OutFile, , OutBuffer$
  LOCATE 13, 26, 0
  PRINT Start&;
  LOCATE 15, 26
  PRINT LOF(OutFile);
  DO
    An$ = INKEY$
    IF LEN(An$) THEN
      IF An$ = CHR$(27) THEN
        CLOSE
        CLEAR
        VIEW PRINT
        COLOR 7, 0
        CLS
        SYSTEM
      END IF
      EXIT DO
    END IF
    EXIT DO
  LOOP
  IF Flag& = 0 THEN
    GOTO Engine
  ELSEIF Flag& = LOF(InFile) + 1 THEN
    GOTO Done
  ELSE
    Start& = Flag&
    GOTO Engine
  END IF
Done:
  CLOSE InFile
  LOCATE 17, 1
  COLOR 15
  PRINT "Reversing Base256 File";
  COLOR 14
  PRINT " FROM ";
  COLOR 15
  PRINT "LSB <> MSB";
  COLOR 14
  PRINT " TO ";
  COLOR 15
  PRINT "MSB <> LSB, Byte:";
  COLOR 14
  X& = 1
  Y& = LOF(OutFile)
  DO UNTIL X& >= Y&
    GET #OutFile, X&, OutBuffer$
    GET #OutFile, Y&, InBuffer$
    PUT #OutFile, X&, InBuffer$
    PUT #OutFile, Y&, OutBuffer$
    LOCATE 17, 62
    PRINT X&;
    X& = X& + 1
    Y& = Y& - 1
  LOOP
  CLOSE
  CLEAR
  LOCATE 22, 34
  COLOR 7
  PRINT "** (Done) **"
  SYSTEM

